<script lang="ts">
	import { onMount } from 'svelte';
	import type { AuthSession } from '@supabase/supabase-js';
	import { supabase } from '$lib/supabaseClient';

	export let session: AuthSession;

	let loading = false;
	let username: string | null = null;
	let website: string | null = null;
	let avatarUrl: string | null = null;

	onMount(() => {
		getProfile();
	});

	const getProfile = async () => {
		try {
			loading = true;
			const { user } = session;

			const { data, error, status } = await supabase
				.from('profiles')
				.select(`username, website, avatar_url`)
				.eq('id', user.id)
				.single();

			if (data) {
				username = data.username;
				website = data.website;
				avatarUrl = data.avatar_url;
			}

			if (error && status !== 406) throw error;
		} catch (error) {
			if (error instanceof Error) {
				alert(error.message);
			}
		} finally {
			loading = false;
		}
	};

	async function updateProfile() {
		try {
			loading = true;
			const { user } = session;

			const updates = {
				id: user.id,
				username,
				website,
				avatar_url: avatarUrl,
				updated_at: new Date()
			};

			let { error } = await supabase.from('profiles').upsert(updates);

			if (error) throw error;
		} catch (error) {
			if (error instanceof Error) {
				alert(error.message);
			}
		} finally {
			loading = false;
		}
	}

	async function signOut() {
		try {
			loading = true;
			let { error } = await supabase.auth.signOut();
			if (error) throw error;
		} catch (error) {
			if (error instanceof Error) {
				alert(error.message);
			}
		} finally {
			loading = false;
		}
	}
	import Home from './home/+page.svelte';	
</script>
<Home/>
	<!-- <form class="w-fit" on:submit|preventDefault={updateProfile}>
		<div class="grid grid-cols-4">
			<label class="p-1 m-1" for="email">Email</label>
			<input
				id="email"
				class="shadow rounded border p-1 m-1 col-span-3"
				type="text"
				value={session.user.email}
				disabled
			/>
		</div>
		<div class="grid grid-cols-4">
			<label class="p-1 m-1" for="username">Name</label>
			<input
				id="username"
				class="shadow rounded border p-1 m-1 col-span-3"
				type="text"
				bind:value={username}
			/>
		</div>
		<div class="grid grid-cols-4">
			<label class="p-1 m-1" for="website">Website</label>
			<input
				id="website"
				class="shadow rounded border p-1 m-1 col-span-3"
				type="website"
				bind:value={website}
			/>
		</div>
	
		<input
			type="submit"
			class="bg-blue-500 hover:bg-blue-700 text-white font-bold m-1 py-1 px-2 rounded"
			value={loading ? 'Loading...' : 'Update'}
			disabled={loading}
		/>
		<button
			class="bg-red-500 hover:bg-red-700 text-white font-bold m-1 py-1 px-2 rounded"
			on:click={signOut}
			disabled={loading}
		>
			Sign Out
		</button>
	</form> -->
